;************************************************************************
;	BIOSŃ[hŏ̃ZN^
;	
;	vOŜʂāAZOg̒l0x0000ƂB
;	(DS==ES==0)
;	
;************************************************************************

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		BOOT_LOAD						; [hAhXAZuɎw

;************************************************************************
;	Gg|Cg
;************************************************************************
entry:
		;---------------------------------------
		; BPB(BIOS Parameter Block)
		;---------------------------------------
		jmp		ipl								; IPLփWv
		times	90 - ($ - $$) db 0x90			; 

		;---------------------------------------
		; IPL(Initial Program Loader)
		;---------------------------------------
ipl:
		cli										; // 荞݋֎~

		mov		ax, 0x0000						; AX = 0x0000;
		mov		ds, ax							; DS = 0x0000;
		mov		es, ax							; ES = 0x0000;
		mov		ss, ax							; SS = 0x0000;
		mov		sp, BOOT_LOAD					; SP = 0x7C00;

		sti										; // 荞݋

		mov		[BOOT + drive.no], dl			; u[ghCuۑ

		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0						; puts(.s0);

		;---------------------------------------
		; c̃ZN^Sēǂݍ
		;---------------------------------------
		mov		bx, BOOT_SECT - 1				; BX = c̃u[gZN^;
		mov		cx, BOOT_LOAD + SECT_SIZE		; CX = ̃[hAhX;

		cdecl	read_chs, BOOT, bx, cx			; AX = read_chs(.chs, bx, cx);

		cmp		ax, bx							; if (AX != c̃ZN^)
.10Q:	jz		.10E							; {
.10T:	cdecl	puts, .e0						;   puts(.e0);
		call	reboot							;   reboot(); // ċN
.10E:											; }

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_2							; u[g̑2Xe[W

		;---------------------------------------
		; f[^
		;---------------------------------------
.s0		db	"Booting...", 0x0A, 0x0D, 0
.e0		db	"Error:sector read", 0

;************************************************************************
;	u[ghCuɊւ
;************************************************************************
ALIGN 2, db 0
BOOT:											; u[ghCuɊւ
	istruc	drive
		at	drive.no,		dw	0				; hCuԍ
		at	drive.cyln,		dw	0				; C:V_
		at	drive.head,		dw	0				; H:wbh
		at	drive.sect,		dw	2				; S:ZN^
	iend

;************************************************************************
;	W[
;************************************************************************
%include	"../modules/real/puts.s"
%include	"../modules/real/reboot.s"
%include	"../modules/real/read_chs.s"

;************************************************************************
;	u[gtOi擪512oCg̏Ij
;************************************************************************
		times	510 - ($ - $$) db 0x00
		db	0x55, 0xAA

;************************************************************************
;	u[g̑2Xe[W
;************************************************************************
stage_2:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0						; puts(.s0);

		;---------------------------------------
		; ̏I
		;---------------------------------------
		jmp		$								; while (1) ; // [v

		;---------------------------------------
		; f[^
		;---------------------------------------
.s0		db	"2nd stage...", 0x0A, 0x0D, 0

;************************************************************************
;	pfBO
;************************************************************************
		times BOOT_SIZE - ($ - $$)		db	0	; pfBO

