;************************************************************************
;
;	J[l
;
;************************************************************************

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		KERNEL_LOAD						; J[l̃[hAhX

[BITS 32]
;************************************************************************
;	Gg|Cg
;************************************************************************
kernel:
		;---------------------------------------
		; tHgAhX擾
		;---------------------------------------
		mov		esi, BOOT_LOAD + SECT_SIZE		; ESI   = 0x7C00 + 512
		movzx	eax, word [esi + 0]				; EAX   = [ESI + 0] // ZOg
		movzx	ebx, word [esi + 2]				; EBX   = [ESI + 2] // ItZbg
		shl		eax, 4							; EAX <<= 4;
		add		eax, ebx						; EAX  += EBX;
		mov		[FONT_ADR], eax					; FONT_ADR[0] = EAX;

		;---------------------------------------
		; 8rbg̉
		;---------------------------------------
		mov		ah, 0x07						; AH = ݃v[w(Bit:----IRGB)
		mov		al, 0x02						; AL = }bv}XNWX^i݃v[wj
		mov		dx, 0x03C4						; DX = V[PT|[g
		out		dx, ax							; // |[go

		mov		[0x000A_0000 + 0], byte 0xFF

		mov		ah, 0x04						; AH = ݃v[w(Bit:----IRGB)
		out		dx, ax							; // |[go

		mov		[0x000A_0000 + 1], byte 0xFF    ; // 8hbg̉

		mov		ah, 0x02						; AH = ݃v[w(Bit:----IRGB)
		out		dx, ax							; // |[go

		mov		[0x000A_0000 + 2], byte 0xFF    ; // 8hbg̉

		mov		ah, 0x01						; AH = ݃v[w(Bit:----IRGB)
		out		dx, ax							; // |[go

		mov		[0x000A_0000 + 3], byte 0xFF    ; // 8hbg̉

		;---------------------------------------
		; ʂ؂鉡
		;---------------------------------------
		mov		ah, 0x02						; AH = ݃v[w(Bit:----IRGB)
		out		dx, ax							; // |[go

		lea		edi, [0x000A_0000 + 80]			; EDI = VRAMAhX;
		mov		ecx, 80							; ECX = JԂ;
		mov		al, 0xFF						; AL  = rbgp^[;
		rep stosb								; *EDI++ = AL;

		;---------------------------------------
		; 2sڂ8hbg̋`
		;---------------------------------------
		mov		edi, 1							; EDI  = s;

		shl		edi, 8							; EDI *= 256;
		lea		edi, [edi * 4 + edi + 0xA_0000]	; EDI  = VRAMAhX;

		mov		[edi + (80 * 0)], word 0xFF
		mov		[edi + (80 * 1)], word 0xFF
		mov		[edi + (80 * 2)], word 0xFF
		mov		[edi + (80 * 3)], word 0xFF
		mov		[edi + (80 * 4)], word 0xFF
		mov		[edi + (80 * 5)], word 0xFF
		mov		[edi + (80 * 6)], word 0xFF
		mov		[edi + (80 * 7)], word 0xFF

		;---------------------------------------
		; 3sڂɕ`
		;---------------------------------------
		mov		esi, 'A'						; ESI  = R[h;
		shl		esi, 4							; ESI *= 16;
		add		esi, [FONT_ADR]					; ESI  = FONT_ADR[R[h];

		mov		edi, 2							; EDI  = s;
		shl		edi, 8							; EDI *= 256;
		lea		edi, [edi * 4 + edi + 0xA_0000]	; EDI  = VRAMAhX;

		mov		ecx, 16							; ECX  = 16;
.10L:											; do
												; {
		movsb									;   *EDI++ = *ESI++;
		add		edi, 80 - 1						;   EDI += 79; // 1hbg
		loop	.10L							; }while (--ECX);

		;---------------------------------------
		; ̏I
		;---------------------------------------
		jmp		$								; while (1) ; // [v

ALIGN 4, db 0
FONT_ADR:	dd	0

;************************************************************************
;	pfBO
;************************************************************************
		times KERNEL_SIZE - ($ - $$) db 0x00	; pfBO

