;************************************************************************
;	荞ݏF#NM(DNA:foCXgps)
;************************************************************************
int_nm:
		;---------------------------------------
		; yWX^̕ۑz
		;---------------------------------------
		pusha
		push	ds
		push	es

		;---------------------------------------
		; J[lpZN^ݒ
		;---------------------------------------
		mov		ax, DS_KERNEL					;
		mov		ds, ax							;
		mov		es, ax							;

		;---------------------------------------
		; ^XNXCb`tONA
		;---------------------------------------
		clts									; CR0.TS = 0;

		;---------------------------------------
		; O/FPUgp^XN
		;---------------------------------------
		mov		edi, [.last_tss]				; EDI = OFPUgp^XNTSS
		str		esi								; ESI = FPUgp^XNTSS
		and		esi, ~0x0007					; // x}XN

		;---------------------------------------
		; FPȔ񗘗p`FbN
		;---------------------------------------
		cmp		edi, 0							; if (0 != EDI)     // Ogp^XN
		je		.10F							; {
												;   
		cmp		esi, edi						;   if (ESI != EDI) // قȂ^XN
		je		.12E							;   {
												;     
		cli										;     // 荞݋֎~

		;---------------------------------------
		; OFPUReLXgۑ
		;---------------------------------------
		mov		ebx, edi						;     // Õ^XN
		call	get_tss_base					;     // TSSAhX擾
		call	save_fpu_context				;     // FPŨReLXgۑ

		;---------------------------------------
		; FPUReLXg𕜋A
		;---------------------------------------
		mov		ebx, esi						;     // ̃^XN
		call	get_tss_base					;     // TSSAhX擾
		call	load_fpu_context				;     // FPŨReLXg𕜋A
												;     
		sti										;     // 荞݋
.12E:											;   }
		jmp		.10E							; }
.10F:											; else
												; {
												;   
		cli										;   // 荞݋֎~

		;---------------------------------------
		; FPUReLXg𕜋A
		;---------------------------------------
		mov		ebx, esi						;   // ̃^XN
		call	get_tss_base					;   // ݂̃^XNTSSAhX擾
		call	load_fpu_context				;   // FPŨReLXg𕜋A
												;   
		sti										;   // 荞݋
.10E:											; }
												; 
		mov		[.last_tss], esi				; // FPUgp^XNۑ

		;---------------------------------------
		; yWX^̕Az
		;---------------------------------------
		pop		es
		pop		ds
		popa

		iret

ALIGN 4, db 0
.last_tss:	dd		0

;************************************************************************
; GDT̃ZN^̃x[XAhX擾
;------------------------------------------------------------------[IN]--
;	EBX : ZN^
;-----------------------------------------------------------------[OUT]--
;	EAX : x[XAhX
;************************************************************************
get_tss_base:
		mov		eax, [GDT + ebx + 2]			; EAX   = TSS[23: 0];
		shl		eax, 8							; EAX <<= 8;
        mov     al,  [GDT + ebx + 7]            ;  AL   = TSS[31:24];
		ror		eax, 8							; EAX >>= 8;

		ret

;************************************************************************
; FPŨReLXgۑ
;------------------------------------------------------------------[IN]--
;	EAX : TSS̐擪AhX
;************************************************************************
save_fpu_context:
		fnsave	[eax + 104]						; // FPUReLXgۑ
		mov		[eax + 104 + 108], dword 1		; saved = 1;

		ret

;************************************************************************
; FPŨReLXg𕜋A
;------------------------------------------------------------------[IN]--
;	EAX : TSS̐擪AhX
;************************************************************************
load_fpu_context:
		cmp		[eax + 104 + 108], dword 0		; if (0 == saved)
		jne		.10F							; {
		fninit									;    // FPȔ
		jmp		.10E							; }
.10F:											; else
												; {
		frstor	[eax + 104]						;   // FPUReLXg𕜋A
.10E:											; }
		ret

